package com.jay.monitor.data.client;

import com.jay.monitor.data.core.model.serializable.URLDataDTO;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

/**
 * @Module TODO
 * @Description TODO
 * @Author liukaixiong
 * @Date 2020/10/23 19:38
 */
@Component
public class MonitorSendProducer implements ApplicationContextAware {

    private static ApplicationContext applicationContext;

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        MonitorSendProducer.applicationContext = applicationContext;
    }

    /**
     * 发送数据
     *
     * @param dataDTO
     * @throws Exception
     */
    public static void sendMsg(URLDataDTO dataDTO) throws Exception {
        MonitorDataClient monitorData = getMonitorData();
        if (monitorData != null) {
            getMonitorData().sendObjectMsg(dataDTO);
        }
    }

    private static MonitorDataClient getMonitorData() {
        return applicationContext.getBean(MonitorDataClient.class);
    }
}
