package com.jay.monitor.data.server.process;

import com.alibaba.fastjson.JSON;
import com.alipay.remoting.BizContext;
import com.jay.monitor.data.core.enums.MonitorDataConstants;
import com.jay.monitor.data.core.model.serializable.URLDataDTO;
import com.jay.monitor.data.server.daos.JayMonitorUrlLogMapper;
import com.jay.monitor.data.server.daos.JayMonitorUrlMapper;
import com.jay.monitor.data.server.models.entity.JayMonitorUrl;
import com.jay.monitor.data.server.models.entity.JayMonitorUrlLog;
import com.jay.monitor.data.server.utils.DataUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Module TODO
 * @Description TODO
 * @Author liukaixiong
 * @Date 2020/10/23 15:52
 */
@Component
public class URLUserProcess extends AbstractUserProcess<URLDataDTO> {

    private Logger logger = LoggerFactory.getLogger(URLUserProcess.class);

    @Autowired
    private JayMonitorUrlMapper urlMapper;

    @Autowired
    private JayMonitorUrlLogMapper urlLogMapper;

    @Override
    public Object handleRequest0(BizContext bizCtx, URLDataDTO request) throws Exception {
        logger.info("接收到的URL 传输对象:" + JSON.toJSONString(request));

        JayMonitorUrl monitorUrl = new JayMonitorUrl();
        BeanUtils.copyProperties(request, monitorUrl);
        monitorUrl.setApplicationName(DataUtils.getStringValue(request.getApplicationName(), bizCtx.getInvokeContext().get(MonitorDataConstants.INVOKE_CLIENT_NAME)));
        monitorUrl.setApplicationIp(DataUtils.getStringValue(request.getIp(), bizCtx.getInvokeContext().get(MonitorDataConstants.INVOKE_CLIENT_IP)));
        monitorUrl.setCreatedDay(request.getCreateDate());
        monitorUrl.setCreatedTime(request.getCreateDate());
        int id = urlMapper.insert(monitorUrl);

        JayMonitorUrlLog urlLog = new JayMonitorUrlLog();
        urlLog.setMonitorId(id);
        urlLog.setCreateDate(request.getCreateDate());
        urlLog.setLogId(request.getLogId());
        urlLog.setLogText(request.getLogMsg());
        urlLog.setMonitorType(request.getType().name());
        int logId = urlLogMapper.insert(urlLog);

        return request;
    }

    @Override
    public List<String> multiInterest() {
        return getNamesList(URLDataDTO.class);
    }
}
